require_relative 'philosopher'

module StudioGame
  class BerserkPlayer < Philosopher
    def initialize(name, health=100) 
      super(name, health)
      @w00t_count = 0
    end
  
    def berserk?
      @w00t_count > 5
    end
  
    def w00t
      super
      @w00t_count += 1
      puts "#{@name} has gone berserk!" if berserk?
    end
  
    def blam
      berserk? ? w00t : super
    end
  end

  if __FILE__ == $0
    berserker = BerserkPlayer.new("berserker", 60)
    6.times { berserker.w00t }
    2.times {berserker.blam }
    puts berserker.health
  end
end