require_relative 'philosopher'

module StudioGame
  class SloppyPhilosopher < Philosopher
    def initialize(name, health=100)
      super(name, health)
      @w00t_count = 0
    end

    def discovered_epiphanies(epiphany)
      sloppy_thinking = Epiphany.new(epiphany.name, epiphany.points / 2.0)
      super(sloppy_thinking)
    end
  
    def bonus_w00ts?
      @w00t_count % 3 == 0
    end
  
    def w00t
      super
      @w00t_count += 1
      2.times { w00t } if bonus_w00ts? 
    end
  end

  if __FILE__ == $0
    clumsy = SloppyPhilosopher.new("klutz", 205)  
  
    an_indubitable_truth = Epiphany.new(:an_indubitable_truth, 50)
    clumsy.discovered_epiphanies(an_indubitable_truth)
    clumsy.discovered_epiphanies(an_indubitable_truth)
    clumsy.discovered_epiphanies(an_indubitable_truth)
  
    the_problem_of_induction = Epiphany.new(:the_problem_of_induction, 200)
    clumsy.discovered_epiphanies(the_problem_of_induction)
  
    clumsy.each_discovered_epiphany do |epiphany|
      puts "#{epiphany.points} total points from discovering #{epiphany.name}"
    end
    puts "#{clumsy.points} grand total points"
  
    puts clumsy.health
    3.times { clumsy.w00t }
    puts clumsy.health
  end
end